#!/bin/sh
# the next line restarts using wish \
exec wishstep8.0 "$0" "$@"

proc hamster_truncateList {list} {

	set retList {}

	foreach i $list {
		if {$i == {}} {
			continue
		}

		catch [set retList [concat $retList $i]]
	}

	return $retList
}

proc hamster_decodeTag {htTag font} {
	global bgColor textColor linkColor tag imageID trun text seq

	set tagOption {}

	set tagKernel [lindex $htTag 0]

	set imgBd 4
	set imgRel flat

	for {set i 1} {$i<[llength $htTag]} {incr i} {
		set tagOption "$tagOption [lindex $htTag $i]"
	}

	set tagOption [hamster_truncateList $tagOption]

	switch $tagKernel {
		br {
			.base.text insert end \n
		}

		a {
			set para [hamster_searchCloseTag $tagKernel]
			set tTagList {}

			foreach i $tagOption {
				set temp [split $i "="]
				switch [lindex $temp 0] {
					href {
						set href [lindex $temp 1]
					}
				}

				while {[string length $para]>0} {
					set textPointer [string first \< $para]

					if {$textPointer<0} {
						set textPointer end
					}

					if {$textPointer != "end"} {
						incr textPointer -1
					}

					set tTag [hamster_dispText $para $textPointer $font false]

					set tTagList "$tTagList $tTag"

					foreach i $tTagList {
						eval .base.text tag configure $i -foreground $linkColor -underline true
						.base.text tag bind $i <ButtonRelease-1> "hamster_openDoc $href 0"

						.base.text tag bind $i <Enter> {
						    .base.text config -cursor hand2
						}

						.base.text tag bind $i <Leave> {
						    .base.text config -cursor xterm
						}
					}

					set para [string range $para $textPointer end]

					set tagInfo [hamster_getTag $para]
					set para [string range $para [expr [lindex $tagInfo 1]+1] end]
					hamster_decodeTag [lindex $tagInfo 0] $font
				}
			}
		}

		body {
			foreach i $tagOption {
				set temp [split $i "="]
				switch [lindex $temp 0] {
					text {
						set textColor [lindex $temp 1]
					}

					link {
						set linkColor [lindex $temp 1]
					}

					bgcolor {
						set bgColor [lindex $temp 1]
					}
				}
			}

			eval .base.text configure -bg $bgColor -foreground $textColor
		}

		img {
			foreach i $tagOption {
				set temp [split $i "="]
				switch [lindex $temp 0] {
					src {
						set imgSrc [lindex $temp 1]
					}

					border {
						set imgBd [lindex $temp 1]
					}

					relief {
						set imgRel [lindex $temp 1]
					}
				}
			}

			eval image create photo img$imageID -file $imgSrc
			eval label .base.text.img$imageID -image img$imageID -bd $imgBd -relief $imgRel
			.base.text window create end -window .base.text.img$imageID -align baseline
			incr imageID
		}

		hr {
			foreach i $tagOption {
				set temp [split $i "="]
				switch [lindex $temp 0] {
					src {
						set imgSrc [lindex $temp 1]
					}
				}
			}

			eval frame .base.text.img$imageID -bd 1 -relief sunken -width 400 -height 2
			.base.text window create end -window .base.text.img$imageID -align baseline
			incr imageID

			.base.text insert end \n
		}

		h1 {
			set para [hamster_searchCloseTag $tagKernel]

#			set font {Courier 24}
			set font LargeFont

			while {[string length $para]>0} {
				set textPointer [string first \< $para]

				if {$textPointer<0} {
					set textPointer end
				}

				if {$textPointer != "end"} {
					incr textPointer -1
				}

				hamster_dispText $para $textPointer $font false

				set para [string range $para $textPointer end]

				set tagInfo [hamster_getTag $para]
				set para [string range $para [expr [lindex $tagInfo 1]+1] end]

				hamster_decodeTag [lindex $tagInfo 0] $font
			}
		}

		h2 {
			set para [hamster_searchCloseTag $tagKernel]
			set oldFont [.base.text tag cget [expr $tag-1] -font]

#			set font {Courier 18}
			set font MidFont

			while {[string length $para]>0} {
				set textPointer [string first \< $para]

				if {$textPointer<0} {
					set textPointer end
				}

				if {$textPointer != "end"} {
					incr textPointer -1
				}

				hamster_dispText $para $textPointer $font false
				set para [string range $para $textPointer end]

				set tagInfo [hamster_getTag $para]
				set para [string range $para [expr [lindex $tagInfo 1]+1] end]
				hamster_decodeTag [lindex $tagInfo 0] $font
			}
		}

		h3 {
			set para [hamster_searchCloseTag $tagKernel]
			set oldFont [.base.text tag cget [expr $tag-1] -font]

#			set font {Courier 14}
			set font NormalFont

			while {[string length $para]>0} {
				set textPointer [string first \< $para]

				if {$textPointer<0} {
					set textPointer end
				}

				if {$textPointer != "end"} {
					incr textPointer -1
				}

				hamster_dispText $para $textPointer $font false
				set para [string range $para $textPointer end]

				set tagInfo [hamster_getTag $para]
				set para [string range $para [expr [lindex $tagInfo 1]+1] end]
				hamster_decodeTag [lindex $tagInfo 0] $font
			}
		}

		title {
			set para [hamster_searchCloseTag $tagKernel]
			wm title . $para-Hamster
		}
	}
}

proc hamster_getTag {seq} {

	for {set i 1} {$i<[string length $seq]} {incr i} {
		set temp [string index $seq $i]

		if {$temp=="<"} {
			return
		} elseif {$temp==">"} {
			return [list [string range $seq 1 [expr $i-1]] $i]
		}
	}
}

proc hamster_dispText {seq textPointer font underLine} {
	global tag

	.base.text insert end [string range $seq 0 $textPointer] $tag
	.base.text tag configure $tag -font $font -underline $underLine

	incr tag

	return [expr $tag-1]
}

proc hamster_searchCloseTag {tagKernel} {
	global trun text seq

	set primo [expr [string first "</" $seq]+2]

	for {set i $primo} {$i<[string length $seq]} {incr i} {
		set temp [string index $seq $i]

		if {$temp==">"} {
			if {$tagKernel==[string range $seq $primo [expr $i-1]] } {
				set text [expr $primo-3]
				set trun [expr $i+1]
				set ret [string range $seq 0 [expr $primo-3]]
				set seq [string range $seq $trun end]
				return $ret
			}
		}
	}
}

proc hamster_procDoc {} {
	global seq

	set font {Courier 14}

	while {[string length $seq]>0} {
		set textPointer [expr [string first \< $seq]-1]
		hamster_dispText $seq $textPointer $font false

		set seq [string range $seq $textPointer end]

		set tagInfo [hamster_getTag $seq]

		set seq [string range $seq [expr [lindex $tagInfo 1]+1] end]
		hamster_decodeTag [lindex $tagInfo 0] $font
	}
}

proc hamster_openDoc {fname mode} {
	global trun text seq urlList nowOn

	set temp {}

	if {$mode == "0"} {
		set urlList [lrange $urlList 0 [expr $nowOn -1]]

#		if {[string index $fname 0]!="/"} {
#			set fname [pwd]/$fname
#		}

		set urlList [hamster_truncateList "$urlList $fname"]
	}

	if {$nowOn!=0} {
		coolbutton1 .base.middle.arLeft
	}

	if {$nowOn==0} {
		coolbutton1d .base.middle.arLeft
	}

	if {$nowOn<[expr [llength $urlList] -1 ]} {
		coolbutton1 .base.middle.arRight
	}

	if {$nowOn==[expr [llength $urlList]-1]} {
		coolbutton1d .base.middle.arRight
	}

	if {[file extension $fname]!=".hamster"} {
		return
	}

	.base.text delete 1.0 end

	cd [file dirname $fname]


	set hamFile [open $fname r]
	set line [gets $hamFile]

	while {![eof $hamFile]} {
		catch [set seq "$seq$line"]
		set line [gets $hamFile]
	}

	close $hamFile

	set seq [hamster_truncateList $seq]

	incr nowOn

	hamster_procDoc
}

proc hamster_commonBind {} {
	global argv

	bind .base.text <Drop> "hamster_openDoc %D 0"
	hamster_openDoc [lindex $argv 0] 0
}

proc hamster_HistBack {} {
	global urlList nowOn

	incr nowOn -2
	hamster_openDoc [lindex $urlList $nowOn] -1

}

proc hamster_HistForward {} {
	global urlList nowOn

	hamster_openDoc [lindex $urlList $nowOn] -1

}

proc hamster_rootCreate {} {
	global bgColor textColor ttbLib stageColor panelColor

	frame .sp1 -bg $stageColor -width 6 -relief flat
	frame .sp2 -bg $stageColor -width 6 -relief flat

	frame .base -bg $stageColor
	frame .base.upper -bg $stageColor -height 28 -bd 4 -relief flat

	menubutton .base.upper.menu -bg $stageColor -text "File" \
		-menu .base.upper.menu.file -underline 0 \
		-relief flat


	menu .base.upper.menu.file -bg $stageColor -tearoff 0
	.base.upper.menu.file add command -label Open -command ""
	.base.upper.menu.file add command -label Exit -command "exit"

	frame .base.hr1 -bg $stageColor -height 2 -relief sunken -bd 1

	frame .base.middle -bg $stageColor -relief flat -height 48 -bd 4

	image create photo arLeft -file $ttbLib/tb_back.gif
	button .base.middle.arLeft -width 40 -bg $stageColor -bd 2 -relief flat -image arLeft
	.base.middle.arLeft configure -command hamster_HistBack

	coolbutton1d .base.middle.arLeft

	frame .base.middle.sp0 -bg $stageColor -width 10

	image create photo arRight -file $ttbLib/tb_forward.gif
	button .base.middle.arRight -width 40 -bg $stageColor -bd 2 -relief flat -image arRight
	.base.middle.arRight configure -command hamster_HistForward

	coolbutton1d .base.middle.arRight

	image create photo home -file $ttbLib/Hamster_home.gif

	button .base.middle.home -bg $stageColor -image home

	coolbutton1 .base.middle.home

	image create photo hamLogo -file $ttbLib/hamLogo.gif
	label .base.middle.logo -bg $stageColor -bd 2 -relief raise -image hamLogo

	scrollbar .base.textscroll -bg $stageColor -command ".base.text yview"
	text .base.text -yscrollcommand ".base.textscroll set" -bg $bgColor -foreground $textColor
	pack .sp1 -side left -fill both
	pack .base -side left -fill both
	pack .base.upper -fill both
	pack .base.upper.menu -side left

	pack .base.hr1 -fill both
	pack .base.middle -fill both

	pack .base.middle.arLeft -fill both -side left
	pack .base.middle.sp0 -fill both -side left
	pack .base.middle.arRight -fill both -side left
	pack .base.middle.home -fill both -side left

	pack .base.middle.logo -side right


	pack .base.textscroll -side left -fill both
	pack .base.text -side left -fill both -expand 1
	pack .sp2 -side left -fill both

}

#################################
# reading startup file
#
proc ttb_readStartup {} {
	global stageColor panelColor

	if [file exists ~/GNUstep/Library/JunsSTEP/ttbinitrc] {
		set ttbrc [open ~/GNUstep/Library/JunsSTEP/ttbinitrc r]
		set line [split [gets $ttbrc]]

		while {![eof $ttbrc]} {
			switch [lindex $line 0] {
				ttblogo {
					set ttblogo [lindex $line 1]
				}
				ttbbg {
					set stageColor [lindex $line 1]
				}
				ttbfg {
					set panelColor [lindex $line 1]
				}
			}
	        set line [split [gets $ttbrc]]
		}
		close $ttbrc
	} else {
		puts "JunsSTEP isn't installed."
		exit
	}
}

set trun 0
set text 0
set urlList {}
set seq {}
set imageID 0
set tag 0
set bgColor "#c0c0c0"
set textColor "#000000"
set linkColor "#0000ff"
set stageColor "#c0c0c0"
set panelColor "#c0c0c0"
set nowOn 0

set ttblibPath  ~/GNUstep/Library/JunsSTEP/
set ttbLib $ttblibPath/icons/system

source $ttblibPath/functions/coolbutton1.tcl
source $ttblibPath/functions/coolbutton1d.tcl

font create MidFont -compound { timBI18 kanji18 }
font create LargeFont -compound { timBI24 kanji26 }
font create NormalFont -compound { a14 k14 }

ttb_readStartup
hamster_rootCreate
hamster_commonBind

