######################################################
# clipboard on TTB
#
#                                01/16.1998
#				 02/05.1998

proc ttb_clipBoard {datas mode} {
	global ttblibPath panelColor stageColor

	.hidedBuffer delete 1 end
	.hidedBuffer2 delete 0 end

	set datas [split $datas \n]

	for {set counter 0} {$counter<[llength $datas]} {incr counter} {

		set data [lindex $datas $counter]

		if {![winfo exists .clipBoard]} {
			toplevel .clipBoard -bg $panelColor
			wm title .clipBoard "TTB clip board"

			frame .clipBoard.base -bd 10 -bg $panelColor
			pack .clipBoard.base

			frame .clipBoard.base.u -bg $panelColor
			frame .clipBoard.base.m -bg $panelColor
			frame .clipBoard.base.lb -bg $panelColor -relief groove -bd 2
			frame .clipBoard.base.l -bg $panelColor -relief flat -bd 6

			pack .clipBoard.base.u .clipBoard.base.m .clipBoard.base.lb -in .clipBoard.base -fill both
			pack .clipBoard.base.l -in .clipBoard.base.lb -fill both

			scrollbar .clipBoard.scroll -command ".clipBoard.fileList yview" -orient vertical

			label .clipBoard.flTOP -bg $panelColor -text "file path" -font "-adobe-helvetica-bold-r-*--14-*"
			listbox .clipBoard.fileList -bg $stageColor -width 48 -height 16 \
				-yscrollcommand ".clipBoard.scroll set"

			listbox .clipBoard.modeList -width 8 -height 16 -relief flat

			label .clipBoard.dragStart -bg $panelColor -relief groove \
				-text "Drag & Drop from here" -bd 2

			bind .clipBoard.dragStart <Drag> "sub_showFiles_DnD 2"

			button .clipBoard.mkItem -bg $panelColor -text "Make items" \
				-command {ttb_makeItems "[.clipBoard.fileList get 0 end]"}

			button .clipBoard.delLine -bg $panelColor -text "Delete" -command {
				foreach cur [lsort -decreasing [.clipBoard.fileList curselection]] {
					.clipBoard.fileList delete $cur; 
					.clipBoard.modeList delete $cur;
				}
				.hidedBuffer delete 1
				.hidedBuffer insert 1 [.clipBoard.fileList get 0 end]
				.hidedBuffer2 delete 0
				.hidedBuffer2 insert 1 [.clipBoard.fileList get 0 end]
			}

			button .clipBoard.delAll -bg $panelColor -text "Delete all" -command {

				.hidedBuffer delete 1 end
				.hidedBuffer2 delete 0 end
				.clipBoard.fileList delete 0 end
				.clipBoard.modeList delete 0 end
			}

			button .clipBoard.cancel  -bg $panelColor -text "Cancel" \
				-command {destroy .clipBoard}

			pack .clipBoard.flTOP -in .clipBoard.base.u -fill both -side left -anchor n
			pack .clipBoard.dragStart -in .clipBoard.base.m -fill both
			pack .clipBoard.scroll .clipBoard.fileList -in .clipBoard.base.m -fill both -side left
			pack .clipBoard.delLine .clipBoard.delAll .clipBoard.mkItem .clipBoard.cancel \
				-side left -in .clipBoard.base.l -fill both
		}

		.clipBoard.fileList insert end $data

		if {$mode==0} {
			.clipBoard.modeList insert end "file copy -force --"
		} else {
			.clipBoard.modeList insert end "file rename -force --"
		}

		bind .clipBoard.fileList <Double-ButtonRelease-1> {
			set point [.clipBoard.fileList curselection]
			if {$point==""} return
			set procname [.clipBoard.fileList get $point]

			if {[file isdirectory $procname]} {
				ttb_showFiles 1 $procname
			} else {
				ttb_execIF2 $procname 0
			}
		}

		bind .clipBoard.fileList <Double-ButtonRelease-2> {
			set point [.clipBoard.fileList curselection]
			if {$point==""} return
			set procname [.clipBoard.fileList get $point]

			if {[file isdirectory $procname]} {
				ttb_showFiles 1 $procname
			} else {
				ttb_execIF2 $procname 1
			}
		}
	}

	.hidedBuffer2 insert 0 [.clipBoard.fileList get 0 end]
}

