###############################################
#
# ttb_dialog is imported from original tk library.
#

proc ttb_dialog {w title text bitmap x y default args} {
	global tkPriv tcl_platform stageColor panelColor

	catch {destroy $w}
	toplevel $w -class Dialog -bg $panelColor
	wm title $w $title
	wm iconname $w Dialog
	wm protocol $w WM_DELETE_WINDOW { }

	frame $w.bot -bg $panelColor
	frame $w.top -bg $panelColor
	$w.bot configure -relief raised -bd 1
	$w.top configure -relief raised -bd 1
    
	pack $w.bot -side bottom -fill both
	pack $w.top -side top -fill both -expand 1

	option add *Dialog.msg.wrapLength 3i widgetDefault
	label $w.msg -justify left -text $text -bg $panelColor
	$w.msg configure -font {Helvetica 14}
	pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
	if {$bitmap != ""} {
		label $w.bitmap -image $bitmap -bg $panelColor
		pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
	}

	set i 0
	foreach but $args {
		button $w.button$i -text $but -bg $panelColor -command "set tkPriv(button) $i"
		if {$i == $default} {
			$w.button$i configure -default active
		} else {
			$w.button$i configure -default normal
		}
		grid $w.button$i -in $w.bot -column $i -row 0 -sticky ew -padx 10 -pady 2m
		grid columnconfigure $w.bot $i
		incr i
	}

	if {$default >= 0} {
	bind $w <Return> "
		$w.button$default configure -state active -indicatoron 1
		update idletasks
		after 100
		set tkPriv(button) $default
		"
	}

	bind $w <Destroy> {set tkPriv(button) -1}

	wm withdraw $w
	update idletasks

	if {$x=="-32768"} {
		set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
			- [winfo vrootx [winfo parent $w]]]
		set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
			- [winfo vrooty [winfo parent $w]]]
	}

	wm geom $w +$x+$y
	wm deiconify $w

	set oldFocus [focus]
	set oldGrab [grab current $w]
	if {$oldGrab != ""} {
		set grabStatus [grab status $oldGrab]
	}
	grab $w
	if {$default >= 0} {
		focus $w.button$default
	} else {
		focus $w
	}

	tkwait variable tkPriv(button)
	catch {focus $oldFocus}
	catch {
		bind $w <Destroy> {}
		destroy $w
	}
	if {$oldGrab != ""} {
		if {$grabStatus == "global"} {
		grab -global $oldGrab
		} else {
		grab $oldGrab
		}
	}
	return $tkPriv(button)
}

