############################
# permission
#

proc sub_getunixPermission {fname} {

	set perm [string range [lindex [exec ls -ld $fname] 0] 1 end]

	for {set j 0} {$j<3} {incr j} {
		for {set i 0} {$i<3} {incr i} {
			global permcheck$i$j

			if {[lindex [split $perm {}] [expr $j*3+$i]] != "-"} {
				.perm.bottom.u.r.u.$i$j.c select
			} else {
				.perm.bottom.u.r.u.$i$j.c deselect
			}
		}
	}
}

proc sub_setunixPermission {fileName} {

	set flag {}

	for {set j 0} {$j<3} {incr j} {
		set permList {}
		for {set i 0} {$i<3} {incr i} {
			global permcheck$i$j
			eval set temp \$permcheck$i$j

			catch [set permList [concat $permList $temp]]
		}

			catch [set flag [concat $flag [expr ([lindex $permList 2]*1)\
				+([lindex $permList 1]*2)+([lindex $permList 0]*4)]]]
	}

	exec chmod [join $flag {}] $fileName

	destroy .perm
}

proc ttb_unixPermission {fileName} {

	set width 300

	global panelColor ttblibPath

	toplevel .perm

	wm geometry .perm 300x400
	wm title .perm "UNIX permission"

	frame .perm.top -bd 5 -relief flat -bg $panelColor -width $width
	tk_optionMenu .perm.top.menu menubuttonoptions "Access admin." -bg $panelColor
	frame .perm.line1 -bd 1 -relief sunken -height 2 -width $width
	frame .perm.mid -relief flat -bd 10 -bg $panelColor -width $width -height 96
	frame .perm.mid.u -bg $panelColor
	frame .perm.mid.l -bg $panelColor

	if {[file isdirectory $fileName]} {
		image create photo permICN \
			-file $ttblibPath/icons/folders/Folder.gif
	} else {
		image create photo permICN \
			-file $ttblibPath/icons/files/[ttb_execIF2 $fileName 2].gif
	}

	label .perm.mid.u.img -bg $panelColor -image permICN -bd 4 -relief flat
	label .perm.mid.u.fname -bg $panelColor -text [file tail $fileName] -font {Helvetica 18}
	label .perm.mid.l.label -bg $panelColor -text "Path: "

	if {[string length $fileName] > 30} {
		set pathList [split [string trim [pwd] "/"] "/"]
		set len [llength $pathList]
		set prev ""
		for {set i $len} {1} {incr i -1} {
			set elem [lindex $pathList [expr $i -1]]
			set cur "$elem/$prev"
			if {[string length $cur] > 16} {
				if {$i == $len} { set prev $elem}
				set pathTitle "/.../$prev"
				break;
			}
			set prev $cur
		}
		set pathTitle $pathTitle[file tail $fileName]
	} else {
		set pathTitle  $fileName
	}

	label .perm.mid.l.path -bg $panelColor -text $pathTitle

	frame .perm.line2 -bg $panelColor -bd 1 -relief sunken -height 2 -width $width
	frame .perm.bottom -bg $panelColor -relief flat -bd 0 -bg $panelColor -width $width

	frame .perm.bottom.u -bg $panelColor -relief flat -bd 24 -bg $panelColor -width $width

	frame .perm.bottom.u.l -bg $panelColor -bd 4 -relief flat

	label .perm.bottom.u.l.r -bg $panelColor -text read
	label .perm.bottom.u.l.w -bg $panelColor -text write
	label .perm.bottom.u.l.x -bg $panelColor -text execute

	frame .perm.bottom.u.r -bg $panelColor

	frame .perm.bottom.u.r.u -bg $panelColor

	frame .perm.bottom.u.r.l -bg $panelColor

	label .perm.bottom.u.r.l.ow -bg $panelColor -text Owner
	label .perm.bottom.u.r.l.gr -bg $panelColor -text Group
	label .perm.bottom.u.r.l.ot -bg $panelColor -text Other

	frame .perm.bottom.l -bg $panelColor -relief flat -height 48 -bd 10 -bg $panelColor -width $width

	button .perm.bottom.l.ok -bg $panelColor -default active -text OK -width 14 \
		-command "sub_setunixPermission $fileName"
	button .perm.bottom.l.resume -bg $panelColor -default normal -text Resume -width 16 \
		-command "sub_getunixPermission $fileName"

	pack .perm.top .perm.line1 .perm.mid .perm.line2 -side top -fill both
	pack .perm.bottom -expand 1 -side bottom -fill both
	pack .perm.top.menu -anchor center
	pack .perm.mid.u .perm.mid.l -side top -fill both
	pack .perm.mid.u.img .perm.mid.u.fname -side left -anchor center
	pack .perm.mid.l.label .perm.mid.l.path -side left -anchor e
	pack .perm.bottom.u -expand 1 -side top -fill both

	pack .perm.bottom.u.l -side left -fill both
	pack .perm.bottom.u.l.r .perm.bottom.u.l.w .perm.bottom.u.l.x -anchor ne -side top
	pack .perm.bottom.u.r -side left -fill both -expand 1
	pack .perm.bottom.u.r.u .perm.bottom.u.r.l -side top -fill y


	for {set j 0} {$j<3} {incr j} {
		for {set i 0} {$i<3} {incr i} {
			frame .perm.bottom.u.r.u.$i$j -width 48 -height 24 -relief groove -bd 2 
			grid configure .perm.bottom.u.r.u.$i$j -column $j -row $i -sticky e
			checkbutton .perm.bottom.u.r.u.$i$j.c -variable permcheck$i$j
			pack propagate .perm.bottom.u.r.u.$i$j false
			pack .perm.bottom.u.r.u.$i$j.c -in .perm.bottom.u.r.u.$i$j
		}
	}

	pack .perm.bottom.u.r.l.ow .perm.bottom.u.r.l.gr .perm.bottom.u.r.l.ot -anchor ne -side left

	pack .perm.bottom.l -side top -fill both
	pack .perm.bottom.l.resume -side left -anchor n -fill both
	pack .perm.bottom.l.ok -side right -anchor n -fill both

	sub_getunixPermission $fileName
}

