#!/bin/sh
# the next line restarts using wish \
exec wishstep8.0 "$0" "$@"

######################################################
# clipboard on TTB
#
#                                01/16.1998
#				 02/05.1998

proc clipBoard_open {datas mode} {
	global ttblibPath panelColor stageColor

	.hidedBuffer delete 1 end
	.hidedBuffer2 delete 0 end

	set datas [split $datas \n]

	for {set counter 0} {$counter<[llength $datas]} {incr counter} {

		set data [lindex $datas $counter]

		if {![winfo exists .clipBoard]} {
			toplevel .clipBoard -bg $panelColor
			wm title .clipBoard "TTB clip board"

			frame .clipBoard.base -bd 10 -bg $panelColor
			pack .clipBoard.base

			frame .clipBoard.base.u -bg $panelColor
			frame .clipBoard.base.m -bg $panelColor
			frame .clipBoard.base.lb -bg $panelColor -relief groove -bd 2
			frame .clipBoard.base.l -bg $panelColor -relief flat -bd 6

			pack .clipBoard.base.u .clipBoard.base.m .clipBoard.base.lb -in .clipBoard.base -fill both
			pack .clipBoard.base.l -in .clipBoard.base.lb -fill both

			scrollbar .clipBoard.scroll -command ".clipBoard.fileList yview" -orient vertical

			label .clipBoard.flTOP -bg $panelColor -text "file path" -font "-adobe-helvetica-bold-r-*--14-*"
			listbox .clipBoard.fileList -bg $stageColor -width 48 -height 16 \
				-yscrollcommand ".clipBoard.scroll set"

			listbox .clipBoard.modeList -width 8 -height 16 -relief flat

			label .clipBoard.dragStart -bg $panelColor -relief groove \
				-text "Drag & Drop from here" -bd 2

			bind .clipBoard.dragStart <Drag> "sub_showFiles_DnD 2"

			button .clipBoard.mkItem -bg $panelColor -text "Make items" \
				-command {
					send FileViewer.app ttb_makeItems "[.clipBoard.fileList get 0 end]"
				}

			button .clipBoard.delLine -bg $panelColor -text "Delete" -command {
				foreach cur [lsort -decreasing [.clipBoard.fileList curselection]] {
					.clipBoard.fileList delete $cur; 
					.clipBoard.modeList delete $cur;
				}
				.hidedBuffer delete 1
				.hidedBuffer insert 1 [.clipBoard.fileList get 0 end]
				.hidedBuffer2 delete 0
				.hidedBuffer2 insert 1 [.clipBoard.fileList get 0 end]
			}

			button .clipBoard.delAll -bg $panelColor -text "Delete all" -command {

				.hidedBuffer delete 1 end
				.hidedBuffer2 delete 0 end
				.clipBoard.fileList delete 0 end
				.clipBoard.modeList delete 0 end
			}

			button .clipBoard.cancel  -bg $panelColor -text "Cancel" \
				-command {destroy .clipBoard}

			pack .clipBoard.flTOP -in .clipBoard.base.u -fill both -side left -anchor n
			pack .clipBoard.dragStart -in .clipBoard.base.m -fill both
			pack .clipBoard.scroll .clipBoard.fileList -in .clipBoard.base.m -fill both -side left
			pack .clipBoard.delLine .clipBoard.delAll .clipBoard.mkItem .clipBoard.cancel \
				-side left -in .clipBoard.base.l -fill both
		}

		.clipBoard.fileList insert end $data

		if {$mode==0} {
			.clipBoard.modeList insert end "file copy -force --"
		} else {
			.clipBoard.modeList insert end "file rename -force --"
		}

		bind .clipBoard.fileList <Double-ButtonRelease-1> {
			set point [.clipBoard.fileList curselection]
			if {$point==""} return
			set procname [.clipBoard.fileList get $point]

			send FileViewer.app ttb_execIF2 $procname 0
		}

		bind .clipBoard.fileList <Double-ButtonRelease-2> {
			set point [.clipBoard.fileList curselection]
			if {$point==""} return
			set procname [.clipBoard.fileList get $point]

			send FileViewer.app ttb_execIF2 $procname 1
		}
	}

	.hidedBuffer2 insert 0 [.clipBoard.fileList get 0 end]
}

######################################################
# file executor via DnD
#
#                              1/16.1998

proc clipBoard_rootCreate {} {

	global ttblibPath stageColor

	image create photo cbimg -file $ttblibPath/icons/app/ClipBoard.gif

	label .base -image cbimg -bd 0

	pack .base
}

proc clipBoard_bind {} {
	ttb_bind

	bind .base <Drop> {
		clipBoard_open %D [expr %b-1]
	}

	bind . <ButtonPress-1> "raise ."
}

proc sub_showFiles_DnD {channel} {

	if {$channel==2} {
		set fileList [.hidedBuffer2 get 0]
	} else {
		set fileList [.hidedBuffer get $channel]
	}

	set flLen [llength $fileList]

	if {$flLen==0} {
		return
	} 

	set fileList [join $fileList \n]

	if {$flLen==1} {
		dnd_setdata File $fileList
	} else {
		dnd_setdata Files $fileList
	}

	dnd_handledrag
}

proc ttb_showPopup {mode x y fname} {
        global ttbsendList ttbbookmarkList filt

        if {[winfo exists .ttb_popup]} {
                destroy .ttb_popup
        }

        menu .ttb_popup -tearoff 0

        switch $mode {
                "top" {
#                       .ttb_popup add command -label "about ClipBoard" -command ttb_about
                        .ttb_popup add command -label "exit" -command ttb_exit
                }

        }
        tk_popup .ttb_popup $x $y
}

set env_pathList {}

foreach i [join [split [split $env(PATH) :] .]] {
        if {$i!={}} {
                if {$i!=" "} {
                        set temp [split [string trim $i /] /]

                        for {set j 0} {$j<[llength $temp]} {incr j} {

                                if {[lindex $temp $j]=="X11"} {
                                        set temp [lreplace $temp $j $j "X11R6"]
                                }
                        }
                        catch [set env_pathList [concat $env_pathList /[join $temp /]]]
                }
        }
}

set appName ClipBoard

set ttblibPath "~/GNUstep/Library/JunsSTEP/"
set ttblogo "JFLOGO"
set ttbx 640
set ttby 480
set ttbTerm xterm
set itemXMax 0
set stageColor #bfbfbf
set panelColor #bfbfbf
set hlColor #ffffff
set mlColor #dddddd
set slColor #ddffaa
set ttbsendList {}
set ttbbookmarkList {}
set filt 1
set sort 1
set selectedFilesList {}
array names selectedFilesID
set lock 0

source $ttblibPath/functions/ttbinit.tcl

listbox .hidedBuffer
listbox .hidedBuffer2

clipBoard_rootCreate
ttb_resize
clipBoard_bind
