#!/bin/sh
# the next line restarts using wish \
exec wishstep8.0 "$0" "$@"

proc ttb_about {} {

	ttb_dialog .about "about JackSpace" \
		"Jun's STEP xlock utility\n\nver 1.3\n\nJun Wakaya 1998."\
		joinkLogo -32768 0 0 Ok
}

proc joink_exec {} {

	global optList modeName

	foreach i $optList {
		global $i
	}

	set oList {}

	foreach i $optList {
		eval set temp \$$i

		if {$temp == 1} {
			catch [set oList [concat $oList " -$i"]]
		}
	}

	eval exec xlock -mode $modeName $oList &
}

proc joink_tick {} {
	global setTime seconds stopped

	if $stopped return
	after 1000 joink_tick
	set seconds [expr $seconds+1]

	if {$setTime == $seconds} {
		joink_exec
	}
}

proc joink_tack {} {
	global preVTime seconds execu
	if $execu return 
	after 1000 joink_tack
	set seconds [expr $seconds+1]

	if {$preVTime == $seconds} {
		set execu 1
	}
}

proc joink_truncateList {list} {

	set retList {}

	foreach i $list {
		if {$i == {}} {
			continue
		}

		catch [set retList [concat $retList $i]]
	}

	return $retList
}

proc joink_OK {} {

	global execu seconds modeName

	set cursolPoint [.opPanel.1.modelist curselection]
	if {$cursolPoint==""} {
		set modeName random
		return
	}

	set modeName [.opPanel.hidelist get $cursolPoint]
	destroy .opPanel
}

proc joink_preV {} {

	global execu seconds modeName

	set cursolPoint [.opPanel.1.modelist curselection]
	if {$cursolPoint==""} return

	set modeName [.opPanel.hidelist get $cursolPoint]

	set id [exec xlock -inwindow -geometry 64x64 -mode $modeName &]

	set seconds 0
	set execu 0
	joink_tack

	tkwait variable execu

	exec kill $id
}

proc joink_openWindow {} {

	global optList panelColor stageColor modeList

	toplevel .opPanel -bd 10
	wm title .opPanel "Jun's STEP screenlock utility"

	joink_resize .opPanel

	frame .opPanel.1 -bd 10
	scrollbar .opPanel.1.modescroll -command ".opPanel.1.modelist yview"
	listbox .opPanel.1.modelist -width 16 -yscroll ".opPanel.1.modescroll set"
	listbox .opPanel.hidelist -width 16

	frame .opPanel.right -text options -bd 2 -width 100 -relief groove

	frame .opPanel.2
	button .opPanel.2.preV -text preview -command "joink_preV"
	button .opPanel.2.ok -text OK -command "joink_OK"

	grid configure .opPanel.1 -column 0 -row 0 -sticky news
	pack .opPanel.1.modescroll .opPanel.1.modelist -side left -fill both

	grid configure .opPanel.2 -column 0 -row 1 -sticky news
	pack .opPanel.2.preV .opPanel.2.ok -side left -fill both

	grid configure .opPanel.right -columnspan 2 -rowspan 2 -column 2 -row 0 -sticky news

	foreach j $optList {
		checkbutton .opPanel.right.$j -text $j -variable $j
		pack .opPanel.right.$j -side bottom -anchor nw
	}

	foreach i $modeList {
		.opPanel.1.modelist insert end " $i"
		.opPanel.hidelist insert end $i
	}

}

proc joink_resize {toplevel} {

	switch $toplevel {
		root {
			ttb_resize
		}

		opPanel {
			.opPanel configure -bd 10 -relief flat -width 480 -height 320
		}
	}
}

proc joink_rootCreate {ttblibPath} {
	image create photo JoinkImage -file $ttblibPath/icons/app/Joink.gif
	image create photo jfLogo -file "$ttblibPath/icons/system/JFLOGO.gif"

	label .base -image JoinkImage -bd 0 -highlightthickness 0

	pack .base -fill both
	pack propagate .base false
}

proc joink_bind {} {
	global stopped

	ttb_bind

	bind .base <Any-Enter> "set stopped 0;joink_tick"
	bind .base <Any-Leave> "set stopped 1;set seconds 0"
}

proc ttb_showPopup {mode x y fname} {
	global ttbsendList ttbbookmarkList filt

	if {[winfo exists .ttb_popup]} {
		destroy .ttb_popup
	}

	menu .ttb_popup -tearoff 0

	switch $mode {
		"top" {
#			.ttb_popup add command -label "about Joink" -command ttb_about
			.ttb_popup add command -label "Control panel" -command joink_openWindow
			.ttb_popup add command -label "exit" -command ttb_exit
		}

	}
	tk_popup .ttb_popup $x $y
}

set ttblibPath $env(HOME)/GNUstep/Library/JunsSTEP
set ttblogo $ttblibPath/icons/system/JFLOGO.gif
set stageColor {}
set panelColor {}
set stopped 1
set seconds 0
set setTime 10
set preVTime 5
set execu 0
set modeName random
set appName Joink

source $ttblibPath/functions/ttb_dialog.tcl
source $ttblibPath/functions/ttbinit.tcl

image create photo joinkLogo -file $ttblibPath/icons/system/Joink.logo.gif

set modeList {ant ball bat blot bouboule bounce braid bug crystal \
clock daisy dclock demon drift eyes flag flame forest fract galaxy geometry \
grav helix hop hyper ico ifs image julia kaleid laser life life1d life3d \
lightning lisa lissie loop marquee maze mountain nose pacman penrose petal \ 
puzzle pyro qix roll rotor shape sierpinski slip sphere spiral spline \
star strange swarm swirl triangle tube turtle voters wator wire world worm \
cartoon escher gears morph3d pipes superquadrics sproingies blank random}

set optList {usefirst echokeys grabmouse allowaccess enablesaver allowroot remote nolock mono}

foreach i $optList {
	set $i 0
}

joink_rootCreate $ttblibPath
joink_resize root
joink_bind

